.include  "c:\avr\avrasm\appnotes\2313def.inc"
;-----------------------------------------------------------------------------
.def            tt0        = r1    ; used in interrupt
.def            tt1        = r2    ; used in interrupt
.def            dvig       = r3    ; 䫠 ࠢ 
.def            m_up       = r4    ; - 蠣
.def            m_up0      = r5   ; - 蠣
.def            m_left     = r6 
.def            m_left0    = r6 

.def            kar_up     = r7   ; - 蠣     

.def            m_main     = r8    ; ⥪饥 ᫮ ﭨ     
                                   ; (   ) 
.def            k_main     = r9   ;  ᫮ ﭨ   UP/DOWN      

.def            m_speed    = r10    ; c

.def            tmp        = r16
.def            tmp1       = r17
.def            tmp2       = r18
.def            tmp3       = r19
.def            speed      = r20


.def            tmp_u      = r22   ; used in interrupt
.def            tmpSREG    = r27   ; used in INT

;-----------------------------------------------------------------------------
.equ            CS_off  = 0x1C     ; 11100b     
.equ            CS_0    = 4
.equ            CS_1    = 8
.equ            CS_2    = 4+8

.equ            rx_conf         = 1+0x60   ;
.equ            rx_start        = 3+0x60   ; 砫 yp p 
.equ            rx_len          = 16

.equ            tx_conf         = 2   ;
.equ            tx_start        = 20  ; 砫 yp p 
.equ            tx_len          = 16  ; 
;-----------------------------------------------------------------------------
                rjmp    Reset
                rjmp    rese
                rjmp    rese      
                rjmp    rese
                rjmp    rese      
                rjmp    rese
                rjmp    rese
                rjmp    UART_RXC  ;  
                rjmp    rese
                rjmp    rese
                rjmp    rese
;-----------------------------------------------------------------------------
Reset:
                ldi       tmp,0xDF
                out       spl,tmp            ; ⥪

              ;---------------------------------------------------------------
                ldi     tmp,64         ; F=10M Baud=9600
                out     UBRR,tmp       ; tx speed

                ldi     tmp,8+128+16   ; rx + tx = ON
                out     UCR,tmp        ; uart init -   UART
              ;---------------------------------------------------------------

                ldi       tmp,0
                sts       rx_conf,tmp
                sts       tx_conf,tmp
                mov       dvig,tmp

                ldi       tmp,0x80     ; int enable (쭮) 
                out       SREG,tmp

                ldi       tmp,255      ;  direction
                out       ddrb,tmp
                out       ddrd,tmp

                ldi       tmp,255
                out       portb,tmp
                out       portd,tmp
                mov      speed,tmp

                ldi      tmp,0
                out      portb,tmp 
                rcall    wr_1            ;   ॣ

                ldi      tmp,0
                out      portb,tmp 
                rcall    wr_0            ;   ॣ


;-----------------------------------------------------------------------------
main:

               sbrc     dvig,0 
               rcall    step_up
               sbrc     dvig,1
               rcall    step_down
               sbrc     dvig,2          
               rcall    step_left
               sbrc     dvig,3          
               rcall    step_right
               sbrc     dvig,4
               rcall    k_up
               sbrc     dvig,5          
               rcall    k_down

               rjmp     main
;-----------------------------------------------------------------------------
k_up:
               mov      tmp,kar_up        ; - 蠣
               cpi      tmp,0
               breq     k_u01           ; 室       
               dec      tmp             
               mov      kar_up,tmp
               brne     k_u02           ;  0

               mov      tmp,dvig
               andi     tmp,0xff-0x10   ; 塞 䫠 
               mov      dvig,tmp

k_u02:         mov      tmp,k_main
               andi     tmp,0x0F

               rcall    pre_02 

               mov      tmp1,k_main
               andi     tmp1,0xF0
               or       tmp1,tmp        ; ࠭  
               mov      k_main,tmp1 

               out      portb,tmp1 
               rcall    wr_0            ;   ॣ
               rcall    pz
;-------------------------------
k_u01:
               mov      tmp,dvig        ; ᫨ 㦥  "蠣",  
               andi     tmp,0x10        ; 뢮 ᨬ  UART
               brne     k_ue
                
               ldi      tmp,'A'
               out      udr,tmp 
k_ue:
               ret 
;-----------------------------------------------------------------------------
k_down:
               mov      tmp,kar_up      ; - 蠣
               cpi      tmp,0
               breq     k_d01           ; 室       
               dec      tmp             
               mov      kar_up,tmp
               brne     k_d02           ;  0

               mov      tmp,dvig
               andi     tmp,0xff-0x20   ; 塞 䫠 
               mov      dvig,tmp

k_d02:         mov      tmp,k_main
               andi     tmp,0x0F

               rcall    pre_01 

               mov      tmp1,k_main
               andi     tmp1,0xF0
               or       tmp1,tmp        ; ࠭  
               mov      k_main,tmp1 

               out      portb,tmp1 
               rcall    wr_0            ;   ॣ
               rcall    pz

k_d01:
               mov      tmp,dvig        ; ᫨ 㦥  "蠣",  
               andi     tmp,0x20        ; 뢮 ᨬ  UART
               brne     k_de
                
               ldi      tmp,'A'
               out      udr,tmp 
k_de:
               ret 
;-----------------------------------------------------------------------------
step_up:
               ldi      tmp,0           ; ஢ઠ  0,0 (   蠣)
               cp       tmp,m_up        ; (" 直 砩" :) )
               brne     s_u001
               cp       tmp,m_up0
               brne     s_u001
               rjmp     s_u005                
s_u001:
               mov      tmp,m_main
               andi     tmp,0x0F

               rcall    pre_02          ; ८ࠧ

               mov      tmp1,m_main     ; ࠭塞  祭 
               andi     tmp1,0xF0
               or       tmp1,tmp        
               mov      m_main,tmp1 

               out      portb,tmp1      ; 뢮  ⥫ 
               rcall    wr_1            ; (  ॣ)
               rcall    pz

               ldi      tmp,0xff 
               dec      m_up            ; 㬥蠥 - 蠣
               cp       m_up,tmp
               brne     s_u003 
               dec      m_up0
s_u003:
               ldi      tmp,0           ;  ࠧ ஢ઠ  0,0 
               cp       tmp,m_up        ; (㦥  a)
               brne     s_u004
               cp       tmp,m_up0
               brne     s_u004
s_u005:
               mov      tmp,dvig
               andi     tmp,0xff-1      ; 塞 䫠 
               mov      dvig,tmp
                
               ldi      tmp,'A'         ; 뢮 ᨬ  UART
               out      udr,tmp         
               ret
s_u004:
               mov      tmp,dvig
               andi     tmp,0xff-2      ; 塞 䫠   
               mov      dvig,tmp        ; ஭ (- )
               ret 
;-----------------------------------------------------------------------------
;  ८ࠧ뢠 TMP  ᫥饣 蠣  (ᤢ )
;-----------------------------------------------------------------------------
pre_02:
                cpi     tmp,0
                brne    pr_01
                ldi     tmp,1
pr_01:          swap    tmp
                lsl     tmp
                brcc    pr_02
                ldi     tmp,0x10
pr_02:          swap    tmp
                andi    tmp,0x0f        ;    ;)
                ret
;==============================================================================
step_down:
               ldi      tmp,0           ; ஢ઠ  0,0 (   蠣)
               cp       tmp,m_up        ; (" 直 砩" :) )
               brne     s_d001
               cp       tmp,m_up0
               brne     s_d001
               rjmp     s_d005                
s_d001:
               mov      tmp,m_main
               andi     tmp,0x0F

               rcall    pre_01          ; ८ࠧ

               mov      tmp1,m_main     ; ࠭塞  祭 
               andi     tmp1,0xF0
               or       tmp1,tmp        
               mov      m_main,tmp1 

               out      portb,tmp1      ; 뢮  ⥫ 
               rcall    wr_1            ; (  ॣ)
               rcall    pz

               ldi      tmp,0xff 
               dec      m_up            ; 㬥蠥 - 蠣
               cp       m_up,tmp
               brne     s_d003 
               dec      m_up0
s_d003:
               ldi      tmp,0           ;  ࠧ ஢ઠ  0,0 
               cp       tmp,m_up        ; (㦥  a)
               brne     s_d004
               cp       tmp,m_up0
               brne     s_d004
s_d005:
               mov      tmp,dvig
               andi     tmp,0xff-2      ; 塞 䫠 
               mov      dvig,tmp
                
               ldi      tmp,'A'         ; 뢮 ᨬ  UART
               out      udr,tmp         
               ret
s_d004:
               mov      tmp,dvig
               andi     tmp,0xff-1      ; 塞 䫠   
               mov      dvig,tmp        ; ஭ (- )
               ret 
;-----------------------------------------------------------------------------
;  ८ࠧ뢠 TMP  ᫥饣 蠣
;-----------------------------------------------------------------------------
pre_01:
                cpi     tmp,0
                brne    pr_03
                ldi     tmp,0x08
pr_03:          lsr     tmp
                brcc    pr_04
                ldi     tmp,0x08
pr_04:          andi    tmp,0x0f        ;    ;)
                ret
;=============================================================================
step_left:
               ldi      tmp,0           ; ஢ઠ  0,0 (   蠣)
               cp       tmp,m_left      ; (" 直 砩" :) )
               brne     s_l001
               cp       tmp,m_left0
               brne     s_l001
               rjmp     s_l005                
s_l001:
               mov      tmp,m_main
               andi     tmp,0xF0
               swap     tmp 
               rcall    pre_02          ; ८ࠧ
               swap     tmp

               mov      tmp1,m_main     ; ࠭塞  祭 
               andi     tmp1,0x0F
               or       tmp1,tmp        
               mov      m_main,tmp1 

               out      portb,tmp1      ; 뢮  ⥫ 
               rcall    wr_1            ; (  ॣ)
               rcall    pz

               ldi      tmp,0xff 
               dec      m_left          ; 㬥蠥 - 蠣
               cp       m_left,tmp
               brne     s_l003 
               dec      m_left0
s_l003:
               ldi      tmp,0           ;  ࠧ ஢ઠ  0,0 
               cp       tmp,m_left      ; (㦥  a)
               brne     s_l004
               cp       tmp,m_left0
               brne     s_l004
s_l005:
               mov      tmp,dvig
               andi     tmp,0xff-4      ; 塞 䫠 
               mov      dvig,tmp
                
               ldi      tmp,'A'         ; 뢮 ᨬ  UART
               out      udr,tmp         
               ret
s_l004:
               mov      tmp,dvig
               andi     tmp,0xff-8      ; 塞 䫠   
               mov      dvig,tmp        ; ஭ (- )
               ret 

;=============================================================================
step_right:
               ldi      tmp,0           ; ஢ઠ  0,0 (   蠣)
               cp       tmp,m_left      ; (" 直 砩" :) )
               brne     s_r001
               cp       tmp,m_left0
               brne     s_r001
               rjmp     s_r005                
s_r001:
               mov      tmp,m_main
               andi     tmp,0xF0
               swap     tmp 
               rcall    pre_01          ; ८ࠧ
               swap     tmp

               mov      tmp1,m_main     ; ࠭塞  祭 
               andi     tmp1,0x0F
               or       tmp1,tmp        
               mov      m_main,tmp1 

               out      portb,tmp1      ; 뢮  ⥫ 
               rcall    wr_1            ; (  ॣ)
               rcall    pz

               ldi      tmp,0xff 
               dec      m_left          ; 㬥蠥 - 蠣
               cp       m_left,tmp
               brne     s_r003 
               dec      m_left0
s_r003:
               ldi      tmp,0           ;  ࠧ ஢ઠ  0,0 
               cp       tmp,m_left      ; (㦥  a)
               brne     s_r004
               cp       tmp,m_left0
               brne     s_r004
s_r005:
               mov      tmp,dvig
               andi     tmp,0xff-8      ; 塞 䫠 
               mov      dvig,tmp
                
               ldi      tmp,'A'         ; 뢮 ᨬ  UART
               out      udr,tmp         
               ret
s_r004:
               mov      tmp,dvig
               andi     tmp,0xff-4      ; 塞 䫠   
               mov      dvig,tmp        ; ஭ (- )
               ret 
;=============================================================================
wr_1:   
               in       tmp,pind        
               andi     tmp,0xE3        ; 11100011b
               ori      tmp,CS_1 
               out      portd,tmp
               ori      tmp,CS_off
               out      portd,tmp
               ret
;-----------------------------------------------------------------------------
wr_0:   
               in       tmp,pind        
               andi     tmp,0xE3        ; 11100011b
               ori      tmp,CS_0
               out      portd,tmp
               ori      tmp,CS_off
               out      portd,tmp
               ret
;-----------------------------------------------------------------------------
rese:
                 reti
;-----------------------------------------------------------------------------
pz:
                ldi     tmp3,2
m03:            mov     tmp2,m_speed
m02:            ldi     tmp1,255
m01:            dec     tmp1
                cpi     tmp1,1
                brne    m01
                dec     tmp2
                cpi     tmp2,1
                brne    m02
                dec     tmp3
                cpi     tmp3,1
                brne    m03
                ret

;------------------------------------------------------------------------------
UART_RXC:
               in       tmpSREG,SREG

               lds      Zl,rx_conf
               andi     Zl,0x0f
               cpi      Zl,rx_len-1        ; 0x0f -  ;)
               breq     out_rol            ;uart_01
               subi     Zl,0x100-rx_start  ; = rx_start+ ( rx_conf AND 0x0f)
o_r02:         ldi      Zh,0       
               in       tt0,UDR
               st       Z,tt0              ; A p   
               lds      Zl,rx_conf
               inc      Zl
               sts      rx_conf,Zl
               rcall    parser
               out      SREG,tmpSREG
               reti

out_rol:       ldi       Zl,rx_start+1            ; ᤢ yp
o_r01:         ld        tt0,Z  
               dec       Zl
               st        Z,tt0
               inc       Zl
               inc       Zl
               cpi       Zl,rx_start+rx_len
               brlo      o_r01                 ; <
               dec       Zl
               dec       Zl

               ldi       Zh,0       
               in        tt0,UDR
               st        Z,tt0              ; A p   
               rcall     parser
               out       SREG,tmpSREG
               reti
;-----------------------------------------------------------------------------
parser:
               clr       tt0
               clr       tt1 
               lds       Zl,rx_conf
               andi      Zl,0x0f
               cpi       Zl,rx_len-1
               brne      p01            ; yp  
               ldi       Zl,rx_start
               ld        tmp_u,Z+
               cpi       tmp_u,'A'
               brne      p01 
               ld        tmp_u,Z+
               cpi       tmp_u,'Z'
               brne      p01 

               ldi       tmp_u,0x41+0x5A   ;'A'+'Z'
               mov       tt0,tmp_u

p02:           ld        tmp_u,Z+         ; ⠥   crc ;) 
               add       tt0,tmp_u
               ldi       tmp_u,0            ; clear
               adc       tt1,tmp_u
               cpi       Zl,rx_start+rx_len-3
               brlo      p02              ; <

;               dec       Zl

               ld        tmp_u,Z+          ; pp塞 crc
               cp        tmp_u,tt1             
;               brne      p01
               ld        tmp_u,Z+
               cp        tmp_u,tt0             
;               brne      p01


               ldi      Zl,rx_start+2
               ld       tmp_u,Z+

;               out      UDR,tmp_u       ; output

               cpi      tmp_u,'0'
               brne     p03
               rcall    go_00
               rjmp     p01  

p03:           cpi      tmp_u,'1'
               brne     p04
               rcall    go_01
               rjmp     p01
                                
p04:           cpi      tmp_u,'2' 
               brne     p05
               rcall    go_02
               rjmp     p01
                              
p05:           cpi      tmp_u,'3' 
               brne     p06
               rcall    go_03
               rjmp     p01

p06:           cpi      tmp_u,'4' 
               brne     p07
               rcall    go_04
               rjmp     p01

p07:           cpi      tmp_u,'5' 
               brne     p08
               rcall    go_05
               rjmp     p01

p08:           cpi      tmp_u,'6' 
               brne     p09
               rcall    go_06
               rjmp     p01

p09:           cpi      tmp_u,'7' 
               brne     p10
               rcall    go_07
               rjmp     p01
p10:


p01:               
               ret 
;-----------------------------------------------------------------------------
go_00:
               ldi      tmp_u,0         ; ᨫ 䫠 
               mov      dvig,tmp_u 

                ldi      tmp_u,0
                out      portb,tmp_u

               in       tmp_u,pind        
               andi     tmp_u,0xE3        ; 11100011b
               ori      tmp_u,CS_1 
               out      portd,tmp_u
               ori      tmp_u,CS_off
               out      portd,tmp_u

                ldi      tmp_u,0
                out      portb,tmp_u

               in       tmp_u,pind        
               andi     tmp_u,0xE3        ; 11100011b
               ori      tmp_u,CS_0 
               out      portd,tmp_u
               ori      tmp_u,CS_off
               out      portd,tmp_u

               ret 

;-----------------------------------------------------------------------------
go_01:
               ldi      tmp_u,1         ; ⠭ 䫠 
               or       dvig,tmp_u 
g_01:
               ld       tmp_u,Z+         ; - 蠣
               mov      m_up,tmp_u

               ld       tmp_u,Z+         ; ᪮
               mov      m_speed,tmp_u

               ld       tmp_u,Z+         ; - 蠣 2
               mov      m_up0,tmp_u
               ret 
;-----------------------------------------------------------------------------
go_02:
               ldi      tmp_u,2         ; ⠭ 䫠 
               or       dvig,tmp_u 
               rjmp     g_01
;-----------------------------------------------------------------------------
go_03:
               ldi      tmp_u,4         ; ⠭ 䫠 
               or       dvig,tmp_u 
g_02:
               ld       tmp_u,Z+         ; - 蠣
               mov      m_left,tmp_u
               ld       tmp_u,Z+          ; ᪮
               mov      m_speed,tmp_u
               ld       tmp_u,Z+         ; - 蠣
               mov      m_left0,tmp_u
               ret 
;-----------------------------------------------------------------------------
go_04:
               ldi      tmp_u,8         ; ⠭ 䫠 
               or       dvig,tmp_u 
               rjmp     g_02
;-----------------------------------------------------------------------------
go_05:
               ldi      tmp_u,0x10         ; ⠭ 䫠 
               or       dvig,tmp_u 
g_03:
               ld       tmp_u,Z+         ; - 蠣
               mov      kar_up,tmp_u
               ld       tmp_u,Z          ; ᪮
               mov      m_speed,tmp_u
               ret 
;-----------------------------------------------------------------------------
go_06:
               ldi      tmp_u,0x20      ; ⠭ 䫠 
               or       dvig,tmp_u 
               rjmp     g_03
;-----------------------------------------------------------------------------
; kar_free
;-----------------------------------------------------------------------------
go_07:
                ldi      tmp_u,0
                out      portb,tmp_u

               in       tmp_u,pind
               andi     tmp_u,0xE3        ; 11100011b
               ori      tmp_u,CS_0
               out      portd,tmp_u
               ori      tmp_u,CS_off
               out      portd,tmp_u
                
               ret 


